#TEMPLATE (ABCDataStar_Tools, 'Do more with little...'),Family('ABC')
#! 
#! Author    : Wolter Nijmeijer
#! Date      : 22.05.1999
#! Version   : v2.1
#! Copyright : DataStar Automatisering, Bennekom (NL)
#! ----------------------------------------------------------------------------------------------
#! Changed by: Version  Date        Comments
#! WcN       : v3.0     16.03.01    Added Code and Extension template xGlobalQueueWithTableDetails
#!                                  to create a Global Q that holds Table/Field data to use in your
#!                                  own filters (or whatever)
#! WcN       : v2.0     22.05.99    Made it ABC compatible
#! Initial   : v1.0     27.12.96    Initial version
#! ----------------------------------------------------------------------------------------------
#! 
#EXTENSION (ShowKeyStatus, 'Display the state of the NUM, CAPS and SCROLL-LOCK Keys in the Status bar'), PROCEDURE, LAST
#RESTRICT WHERE(UPPER(%ProcedureTemplate) = 'FRAME')
#ENDRESTRICT
#DISPLAY ('')
#BOXED ('  DataTools v2.0')
#DISPLAY ('')
#DISPLAY ('Author: Wolter Nijmeijer')
#DISPLAY ('Date  : 22.05.1999')
#DISPLAY ('')
#DISPLAY ('Copyright 1996,1999 DataStar Automatisering')
#DISPLAY ('                    Bennekom (NL)')
#DISPLAY ('                    All rights reserved')
#DISPLAY ('')
#ENDBOXED
#BOXED ('  How to use this template?  ')
#DISPLAY ('')
#DISPLAY (' * This template has to be included into your MAIN MDI')
#DISPLAY ('   window also known as "Frame".')
#DISPLAY (' * If you place the status of the keys in the Status')
#DISPLAY ('   bar, be sure to define those Status Bar Sections in')
#DISPLAY ('   the applications Main window.')
#DISPLAY ('   (Make those sections 35 dialog units width each)')
#DISPLAY ('')
#ENDBOXED
#DISPLAY ('')
#BUTTON ('Edit "ShowKeyStatus" properties'), AT(10,, 180)
#SHEET
#TAB (' NumLock Key ')
  #BOXED ('  Properties for the NumLock key  ')
    #DISPLAY ('')
    #PROMPT ('Display state of the NumLock key', CHECK), %ShowNumLock, DEFAULT(0), AT(10,, 170)
    #ENABLE (%ShowNumLock)
      #PROMPT ('Text when NumLock is &On:', @s6), %NumLockOnText, DEFAULT('NUM')
      #PROMPT ('and when it''s O&ff:', @s6), %NumLockOffText, DEFAULT('')
      #DISPLAY ('')
      #PROMPT ('&Location of status text:', DROP ('Status Bar|Control')), %NumLockDisplayLocation
      #ENABLE (%NumLockDisplayLocation = 'Status Bar')
        #PROMPT ('Status Bar Section:', @n1), %NumLockStatusSection, REQ, DEFAULT(4)
      #ENDENABLE
      #ENABLE (%NumLockDisplayLocation = 'Control')
        #PROMPT ('NumLock Display Control:', CONTROL), %NumlockControl, REQ
      #ENDENABLE
    #ENDENABLE
    #DISPLAY ('')
  #ENDBOXED
#ENDTAB
#TAB (' CapsLock Key ')
  #BOXED ('  Properties for the CapsLock key  ')
    #DISPLAY ('')
    #PROMPT ('Display state of the CapsLock key', CHECK), %ShowCapsLock, DEFAULT(0), AT(10,, 170)
    #ENABLE (%ShowCapsLock)
      #PROMPT ('Text when CapsLock is &On:', @s6), %CapsLockOnText, DEFAULT('CAPS')
      #PROMPT ('and when it''s O&ff:', @s6), %CapsLockOffText, DEFAULT('')
      #DISPLAY ('')
      #PROMPT ('&Location of status text:', DROP ('Status Bar|Control')), %CapsLockDisplayLocation
      #ENABLE (%CapsLockDisplayLocation = 'Status Bar')
        #PROMPT ('Status Bar Section:', @n1), %CapsLockStatusSection, REQ, DEFAULT(5)
      #ENDENABLE
      #ENABLE (%CapsLockDisplayLocation = 'Control')
        #PROMPT ('CapsLock Display Control:', CONTROL), %CapsLockControl, REQ
      #ENDENABLE
    #ENDENABLE
    #DISPLAY ('')
  #ENDBOXED
#ENDTAB
#TAB (' ScrollLock Key ')
  #BOXED ('  Properties for the ScrollLock key  ')
    #DISPLAY ('')
    #PROMPT ('Display state of the ScrollLock key', CHECK), %ShowScrollLock, DEFAULT(0), AT(10,, 170)
    #ENABLE (%ShowScrollLock)
      #PROMPT ('Text when ScrollLock is &On:', @s6), %ScrollLockOnText, DEFAULT('SCRL')
      #PROMPT ('and when it''s O&ff:', @s6), %ScrollLockOffText, DEFAULT('')
      #DISPLAY ('')
      #PROMPT ('&Location of status text:', DROP ('Status Bar|Control')), %ScrollLockDisplayLocation
      #ENABLE (%ScrollLockDisplayLocation = 'Status Bar')
        #PROMPT ('Status Bar Section:', @n1), %ScrollLockStatusSection, REQ, DEFAULT(6)
      #ENDENABLE
      #ENABLE (%ScrollLockDisplayLocation = 'Control')
        #PROMPT ('ScrollLock Display Control:', CONTROL), %ScrollLockControl, REQ
      #ENDENABLE
    #ENDENABLE
    #DISPLAY ('')
  #ENDBOXED
#ENDTAB
#ENDSHEET
#ENDBUTTON
#ATSTART
  #DECLARE (%EventTimer)
#ENDAT
#AT (%WindowEventHandling, 'Timer')
  #SET (%EventTimer, %True)
#ENDAT
#AT (%WindowManagerMethodCodeSection, 'Ask','()'), PRIORITY(2505)
  #IF (%ShowNumLock OR %ShowCapsLock OR %ShowScrollLock)
!-------------------------------------------------------------------------------------------
! Added by ABCDataStar_Tools Extension template "ShowKeyStatus".
IF NOT INRANGE(%Window{Prop:Timer},1,100)
  %Window{Prop:Timer} = 100
END
#INSERT (%ShowKeystateCode)
  #ENDIF
#ENDAT

#AT (%WindowEventHandling, 'Timer')
  #SET (%EventTimer, %True)
  #IF (%ShowNumLock OR %ShowCapsLock OR %ShowScrollLock)
#INSERT (%ShowKeystateCode)
  #ENDIF
#ENDAT

#AT(%WindowManagerMethodCodeSection,'TakeWindowEvent','(),BYTE'),PRIORITY(7535)
  #IF (%ShowNumLock OR %ShowCapsLock OR %ShowScrollLock)
    #IF (NOT %EventTimer)
! Added By DataStar Tools Extension template "ShowKeyStatus".
  OF Event:Timer
  #INSERT (%ShowKeystateCode)
    #ENDIF
  #ENDIF
#ENDAT
#! -----------------------------------------------------------------------------------------
#! This is the GROUP block responsible for the code that will be inserted
#! -----------------------------------------------------------------------------------------
#GROUP (%ShowKeystateCode)
#IF (%ShowNumLock OR %ShowCapsLock OR %ShowScrollLock)

! Added By DataStar Tools Extension template "ShowKeyStatus".
#IF (%ShowNumLock)
  #CASE (%NumLockDisplayLocation)
  #OF ('Control')
IF BAND(KEYSTATE(),2000h)#<!Test the state of the NUM lock key
   %NumlockControl{Prop:Text} = '%NumLockOnText'#<!Its on
ELSE
   %NumlockControl{Prop:Text} = '%NumLockOffText'#<!Its off
END
DISPLAY(%NumlockControl)
  #ELSE
IF BAND(KEYSTATE(),2000h)#<!Test the state of the NUM lock key
   %Window{Prop:StatusText,%NumLockStatusSection} = '%NumLockOnText'#<!Its on
ELSE
   %Window{Prop:StatusText,%NumLockStatusSection} = '%NumLockOffText'#<!Its off
END
  #ENDCASE
#ENDIF
#IF (%ShowCapsLock)
  #CASE (%CapsLockDisplayLocation)
  #OF ('Control')
IF BAND(KEYSTATE(),1000h)#<!Test the state of the CAPS lock key
   %CapsLockControl{Prop:Text} = '%CapsLockOnText'#<!Its on
ELSE
   %CapsLockControl{Prop:Text} = '%CapsLockOffText'#<!Its off
END
DISPLAY(%CapsLockControl)#<!Display the text
  #ELSE
IF BAND(KEYSTATE(),1000h)#<!Test the state of the CAPS lock key
   %Window{Prop:StatusText,%CapsLockStatusSection} = '%CapsLockOnText'#<!Its on
ELSE
   %Window{Prop:StatusText,%CapsLockStatusSection} = '%CapsLockOffText'#<!Its off
END
  #ENDCASE
#ENDIF
#IF (%ShowScrollLock)
  #CASE (%ScrollLockDisplayLocation)
  #OF ('Control')
IF BAND(KEYSTATE(),4000h)#<!Test the state of the Scroll lock key
   %ScrollLockControl{Prop:Text} = '%ScrollLockOnText'#<!Its on
ELSE
   %ScrollLockControl{Prop:Text} = '%ScrollLockOffText'#<!Its off
END
DISPLAY(%ScrollLockControl)
  #ELSE
IF BAND(KEYSTATE(),4000h)#<!Test the state of the Scroll lock key
   %Window{Prop:StatusText,%ScrollLockStatusSection} = '%ScrollLockOnText'#<!Its on
ELSE
   %Window{Prop:StatusText,%ScrollLockStatusSection} = '%ScrollLockOffText'#<!Its off
END
  #ENDCASE
#ENDIF
! End Addition

#ENDIF
#!-----------------------------------------------------------------------
#CODE(cGlobalQueueWithTableDetails,'Fill Global Q with list of Table details used in this application')
#RESTRICT WHERE(UPPER(%ProcedureTemplate) = 'FRAME')
#ENDRESTRICT
#!-----------------------------------------------------------------------
#DISPLAY('This template will fill a global Q with the list')
#DISPLAY('of tables and fields used in this application.')
#DISPLAY(' ')
#DISPLAY('TIP: This Code template needs the GLOBAL part of this')
#DISPLAY('     template also or you get compiler errors.')
#DISPLAY(' ')
#DISPLAY('Template provided by:')
#DISPLAY('            DataStar Automatisering')
#DISPLAY('            Lindelaan 28')
#DISPLAY('            6721 VC  BENNEKOM')
#DISPLAY('            The Netherlands')
#DISPLAY('            http://www.datastar.nl')
#DISPLAY('            info@datastar.nl')
#DISPLAY(' ')
#DISPLAY('march 16, 2001 ')
#DISPLAY(' ')
#DISPLAY('Also Credits to the ABC Free Templates from Vince Sorensen')
#DISPLAY('that I used as a base for this part of the template.')

! Added by ABCDataStar_Tools Template
FREE(gqTableDetails)
#FOR(%File)
GQWTD:TableName    = '%File'
GQWTD:TablePrefix  = '%FilePrefix'
#FOR(%Field)
GQWTD:FieldName    = '%FilePrefix' & ':' & '%FieldID'
GQWTD:FieldPicture = '%FieldPicture'
  ADD(gqTableDetails)
#ENDFOR
#ENDFOR
! End Addition

#!-----------------------------------------------------------------------
#EXTENSION(eGlobalQueueWithTableDetails,'Add Global Q "gqTableDetails" to this Application'),APPLICATION
#!-----------------------------------------------------------------------
#DISPLAY(' ')
#DISPLAY('This Extension template has no prompts or fields but')
#DISPLAY('is required for use of the code template')
#DISPLAY('"cGlobalQueueWithTableDetails" to create a GLOBAL Q')
#DISPLAY('that holds all the tables and fields per table for')
#DISPLAY('this entire application. If you want to use it for')
#DISPLAY('a single procedure only, use the Local variant.')
#DISPLAY(' ')
#DISPLAY('Add the code template in the INIT embed point in your')
#DISPLAY('FRAME procedure to make the Q available throughout')
#DISPLAY('your whole application.')
#DISPLAY(' ')
#DISPLAY('Template provided by:')
#DISPLAY('            DataStar Automatisering')
#DISPLAY('            Lindelaan 28')
#DISPLAY('            6721 VC  BENNEKOM')
#DISPLAY('            The Netherlands')
#DISPLAY('            http://www.datastar.nl')
#DISPLAY('            info@datastar.nl')
#DISPLAY(' ')
#DISPLAY('march 16, 2001 ')
#!-----------------------------------------------------------------------------
#GLOBALDATA

gqTableDetails  Queue,PRE(GQWTD)    !Added by ABCDataStar_Tools template (Remove manually if needed)
FieldName       STRING(40)
FieldPicture    STRING(40)
TableName       STRING(40)
TablePrefix     STRING(14)
    END

#ENDGLOBALDATA
#CODE(cLocalQueueWithTableDetails,'Fill Local Q with list of Table details used in this Procedure')
#!-----------------------------------------------------------------------
#DISPLAY('This code template will fill a local Q with a list')
#DISPLAY('of tables and fields used in this procedure.')
#DISPLAY(' ')
#DISPLAY('TIP: This Code template needs the LOCAL part of this')
#DISPLAY('     template also or you get compiler errors.')
#DISPLAY(' ')
#DISPLAY('Template provided by:')
#DISPLAY('            DataStar Automatisering')
#DISPLAY('            Lindelaan 28')
#DISPLAY('            6721 VC  BENNEKOM')
#DISPLAY('            The Netherlands')
#DISPLAY('            http://www.datastar.nl')
#DISPLAY('            info@datastar.nl')
#DISPLAY(' ')
#DISPLAY('march 16, 2001 ')
#DISPLAY(' ')
#DISPLAY('Also Credits to the ABC Free Templates from Vince Sorensen')
#DISPLAY('that I used as a base for this part of the template.')

! Added by ABCDataStar_Tools Template
FREE(lqTableDetails)
#FOR(%File)
LQWTD:TableName    = '%File'
LQWTD:TablePrefix  = '%FilePrefix'
#FOR(%Field)
LQWTD:FieldName    = '%FilePrefix' & ':' & '%FieldID'
LQWTD:FieldPicture = '%FieldPicture'
  ADD(lqTableDetails)
#ENDFOR
#ENDFOR
! End Addition

#!-----------------------------------------------------------------------
#EXTENSION(eLocalQueueWithTableDetails,'Add Local Q "lqTableDetails" to this Procedure'),PROCEDURE
#!-----------------------------------------------------------------------
#DISPLAY(' ')
#DISPLAY('This Extension template has no prompts or fields but')
#DISPLAY('is required for use of the code template')
#DISPLAY('"cLocalQueueWithTableDetails" to create a LOCAL Q')
#DISPLAY('that holds all the tables and fields per table for')
#DISPLAY('this procedure. If you want to use it for your whole')
#DISPLAY('application, use the Global variant.')
#DISPLAY(' ')
#DISPLAY('Add the code template in the INIT embed point in your')
#DISPLAY('procedure to make the Q available to this prcedure.')
#DISPLAY(' ')
#DISPLAY('Template provided by:')
#DISPLAY('            DataStar Automatisering')
#DISPLAY('            Lindelaan 28')
#DISPLAY('            6721 VC  BENNEKOM')
#DISPLAY('            The Netherlands')
#DISPLAY('            http://www.datastar.nl')
#DISPLAY('            info@datastar.nl')
#DISPLAY(' ')
#DISPLAY('march 16, 2001 ')
#!-----------------------------------------------------------------------------
#LOCALDATA

lqTableDetails  Queue,PRE(LQWTD)        !Added by ABCDataStar_Tools template (Remove manually if needed)
FieldName       STRING(40)
FieldPicture    STRING(40)
TableName       STRING(40)
TablePrefix     STRING(14)
    END

#ENDLOCALDATA
